[tool.poetry]
name = "{{ project_slug }}"
version = "0.1.0"
description = ""
authors = []

[tool.poetry.dependencies]
python = ">=3.7 <3.9"
# Optional dependencies to be part of `test` extra
pytest = {version = "^5.2", optional = true}
pytest-cov = {version = "^2.8.1", optional = true}
PyHamcrest = {version = "^2.0", optional = true}
importlib-metadata = {version = "^1.6.1", optional = true, python = "<3.8"}
# Optional dependencies to be part of `lint` extra
flake8 = {version = "^3.7", optional = true}
flake8-bugbear = {version = "^19.8.0", optional = true}
# Optional dependencies to be part of `type` extra
mypy = {version = "^0.740.0", optional = true}
# Optional dependencies to be part of `format` extra
isort = {version = "^4.3", optional = true}
seed-isort-config = {version = "^1.9.3", optional = true}
black = {version = "^22.10.0", optional = true, allow-prereleases = true}
# Optional dependencies to be part of `repl` extra
bpython = {version = "^0.18", optional = true}
# Optional dependencies for notebooks
jupyter = {version = "^1.0.0", optional = true}
jupyter-contrib-nbextensions = {version = "^0.5", optional = true}
jupytext = {version = "^1.4.0", optional = true}
dash = {version = "^1.7.0", optional = true}
# Data science
colorlover = {version = "^0.3.0", optional = true}
# TODO Add ML deps here as optional
# Non-optional dependencies
pilotis-io = "^0.2.0"
pandas = "^0.25.3"
scikit-learn = "^0.22"
pyarrow = "^0.17.1"
pypandoc = "^1.5"
click = "^8.1.3"
mkdocs = "^1.1.2"

[tool.poetry.extras]
notebook = ["jupyter", "jupyter-contrib-nbextensions", "jupytext"]
ml = [] # TODO add ML deps here
dash = ["dash", "colorlover"]
test = ["importlib-metadata", "pytest", "pytest-cov", "PyHamcrest"]
bdd = ["behave4git", "PyHamcrest"]
lint = ["flake8", "flake8-bugbear", "importlib-metadata", "pydocstyle", "pylint", "yapf"]
type = ["mypy"]
format = ["isort", "seed-isort-config", "black"]
repl = ["bpython"]

[tool.isort]
# following black's doc for compatibility
# See https://github.com/psf/black#how-black-wraps-lines
multi_line_output = 3
include_trailing_comma = true
use_parentheses = true
force_grid_wrap = 0
line_length = 88
known_third_party = ["boto3", "dash", "dash_core_components", "dash_html_components", "hamcrest", "joblib", "jupytext", "lime", "matplotlib", "numpy", "pandas", "plotly", "pytest", "scipy", "sklearn", "skrules"]

[tool.black]
line-length = 88
target_version = ["py37"]

[build-system]
requires = ["poetry==1.0.5"]
build-backend = "poetry.masonry.api"
